import { TransformerContextProvider, TransformerResolverProvider, DBType, DataSourceType } from '@aws-amplify/graphql-transformer-interfaces';
import { TypeNode } from 'graphql';
import { Expression } from 'graphql-mapping-template';
import { IndexDirectiveConfiguration, PrimaryKeyDirectiveConfiguration } from '../types';
import { RDSIndexVTLGenerator, DynamoDBIndexVTLGenerator } from './generators';
export declare function replaceDdbPrimaryKey(config: PrimaryKeyDirectiveConfiguration, ctx: TransformerContextProvider): void;
export declare function updateResolvers(config: PrimaryKeyDirectiveConfiguration, ctx: TransformerContextProvider, resolverMap: Map<TransformerResolverProvider, string>): void;
export declare function attributeTypeFromType(type: TypeNode, ctx: TransformerContextProvider): "S" | "N";
export declare function getResolverObject(config: PrimaryKeyDirectiveConfiguration, ctx: TransformerContextProvider, op: string): TransformerResolverProvider | null;
export declare function ensureCompositeKeySnippet(config: PrimaryKeyDirectiveConfiguration, conditionallySetSortKey: boolean): string;
export declare function setQuerySnippet(config: PrimaryKeyDirectiveConfiguration, ctx: TransformerContextProvider, isListResolver: boolean): import("graphql-mapping-template").CompoundExpressionNode;
export declare function validateSortDirectionInput(config: PrimaryKeyDirectiveConfiguration, isListResolver: boolean): Expression[];
export declare function appendSecondaryIndex(config: IndexDirectiveConfiguration, ctx: TransformerContextProvider): void;
export declare function overrideIndexAtCfnLevel(ctx: TransformerContextProvider, typeName: string, table: any, indexInfo: any): void;
export declare function updateResolversForIndex(config: IndexDirectiveConfiguration, ctx: TransformerContextProvider, resolverMap: Map<TransformerResolverProvider, string>): void;
export declare function mergeInputsAndDefaultsSnippet(): string;
export declare function addIndexToResolverSlot(resolver: TransformerResolverProvider, lines: string[], isSync?: boolean): void;
export declare function constructSyncVTL(syncVTLContent: string, resolver: TransformerResolverProvider): void;
export declare const generateAuthExpressionForSandboxMode: (enabled: boolean) => string;
export declare function getDBInfo(ctx: TransformerContextProvider, modelName: string): DataSourceType;
export declare function getDBType(ctx: TransformerContextProvider, modelName: string): DBType;
export declare const getVTLGenerator: (dbInfo: DataSourceType | undefined) => RDSIndexVTLGenerator | DynamoDBIndexVTLGenerator;
//# sourceMappingURL=resolvers.d.ts.map