import { CfnMapping } from 'aws-cdk-lib';
import { RDSConnectionSecrets } from '@aws-amplify/graphql-transformer-core';
import { GraphQLAPIProvider, RDSLayerMapping } from '@aws-amplify/graphql-transformer-interfaces';
import { IRole } from 'aws-cdk-lib/aws-iam';
import { IFunction } from 'aws-cdk-lib/aws-lambda';
import { Construct } from 'constructs';
import { VpcConfig } from '@aws-amplify/graphql-transformer-interfaces/src';
export type OPERATIONS = 'CREATE' | 'UPDATE' | 'DELETE' | 'GET' | 'LIST' | 'SYNC';
export declare const setRDSLayerMappings: (scope: Construct, mapping?: RDSLayerMapping) => CfnMapping;
export declare const createRdsLambda: (scope: Construct, apiGraphql: GraphQLAPIProvider, lambdaRole: IRole, environment?: {
    [key: string]: string;
} | undefined, sqlLambdaVpcConfig?: VpcConfig) => IFunction;
export declare const createRdsPatchingLambda: (scope: Construct, apiGraphql: GraphQLAPIProvider, lambdaRole: IRole, environment?: {
    [key: string]: string;
} | undefined, sqlLambdaVpcConfig?: VpcConfig) => IFunction;
export declare const createRdsLambdaRole: (roleName: string, scope: Construct, secretEntry: RDSConnectionSecrets) => IRole;
export declare const createRdsPatchingLambdaRole: (roleName: string, scope: Construct, functionArn: string) => IRole;
export declare const generateLambdaRequestTemplate: (tableName: string, operation: string, operationName: string) => string;
export declare const generateGetLambdaResponseTemplate: (isSyncEnabled: boolean) => string;
export declare const generateDefaultLambdaResponseMappingTemplate: (isSyncEnabled: boolean, mutation?: boolean) => string;
//# sourceMappingURL=resolver.d.ts.map